diff --git a/src/api.c b/src/api.c
index 0274f48..96efb9b 100644
--- a/src/api.c
+++ b/src/api.c
@@ -17,35 +17,59 @@
  * along with GNU Robots.  If not, see <http://www.gnu.org/licenses/>.
  */
 
-#include <stdio.h>
-#include <stdlib.h>             /* for abs, free */
+#include <stdlib.h>             /* for free */
 
 #include <glib.h>
 #include <libguile.h>           /* GNU Guile high */
 
-#include "api.h"                /* GNU Robots API */
-#include "main.h"               /* for exit_nicely */
+#include "config.h"
+#include "configs.h"
 #include "grobot.h"
+#include "api.h"                /* GNU Robots API */
+
+/** Robot object to be used in all the calls to the grobot.h
+ * functions.
+ */
+static GRobot *robot;
 
-extern GRobot *robot;
+/** If TRUE robot action functions will delay for USLEEP_TIME (mainly
+ * done to give time for animations to complete).
+ */
+static gboolean api_move_delay = TRUE;
 
 /* Functions */
 
-SCM
+static SCM
+api_set_move_delay_x (SCM s_b)
+{
+  api_move_delay = scm_is_true(s_b);
+
+  return(SCM_BOOL(scm_is_true(s_b)));
+}
+
+static SCM
 api_robot_turn (SCM s_n)
 {
-  g_robot_turn (robot, scm_to_int (s_n));
+  gboolean retval = g_robot_turn (robot, scm_to_int (s_n));
 
-  return SCM_BOOL (TRUE);
+  if (api_move_delay)
+    g_usleep(USLEEP_TIME);
+  
+  return SCM_BOOL (retval);
 }
 
-SCM
+static SCM
 api_robot_move (SCM s_n)
 {
-  return SCM_BOOL (g_robot_move (robot, scm_to_int (s_n)));
+  gboolean retval = g_robot_move (robot, scm_to_int (s_n));
+
+  if (api_move_delay)
+    g_usleep(USLEEP_TIME);
+
+  return SCM_BOOL (retval);
 }
 
-SCM
+static SCM
 api_robot_smell (SCM s_th)
 {
   gboolean ret;
@@ -57,10 +81,13 @@ api_robot_smell (SCM s_th)
   str = scm_to_locale_string (s_th);
   ret = g_robot_smell (robot, str);
 
+  if (api_move_delay)
+    g_usleep(USLEEP_TIME);
+
   return SCM_BOOL (ret);
 }
 
-SCM
+static SCM
 api_robot_feel (SCM s_th)
 {
   gboolean ret;
@@ -72,10 +99,13 @@ api_robot_feel (SCM s_th)
   str = scm_to_locale_string (s_th);
   ret = g_robot_feel (robot, str);
 
+  if (api_move_delay)
+    g_usleep(USLEEP_TIME);
+
   return SCM_BOOL (ret);
 }
 
-SCM
+static SCM
 api_robot_look (SCM s_th)
 {
   gboolean ret;
@@ -87,28 +117,41 @@ api_robot_look (SCM s_th)
   str = scm_to_locale_string (s_th);
   ret = g_robot_look (robot, str);
 
+  if (api_move_delay)
+    g_usleep(USLEEP_TIME);
+
   return SCM_BOOL (ret);
 }
 
-SCM
+static SCM
 api_robot_grab (void)
 {
-  return SCM_BOOL (g_robot_grab (robot));
+  gboolean retval = g_robot_grab (robot);
+
+  if (api_move_delay)
+    g_usleep(USLEEP_TIME);
+
+  return SCM_BOOL (retval);
 }
 
-SCM
+static SCM
 api_robot_zap (void)
 {
-  return SCM_BOOL (g_robot_zap (robot));
+  gboolean retval = g_robot_zap (robot);
+
+  if (api_move_delay)
+    g_usleep(USLEEP_TIME);
+
+  return SCM_BOOL (retval);
 }
 
-SCM
+static SCM
 api_robot_stop (void)
 {
   return SCM_BOOL (g_robot_stop (robot));
 }
 
-SCM
+static SCM
 api_robot_get_shields (void)
 {
   glong shields;
@@ -119,7 +162,7 @@ api_robot_get_shields (void)
   return (scm_from_long (shields));
 }
 
-SCM
+static SCM
 api_robot_get_energy (void)
 {
   glong energy;
@@ -130,7 +173,7 @@ api_robot_get_energy (void)
   return (scm_from_long (energy));
 }
 
-SCM
+static SCM
 api_robot_get_score (void)
 {
   glong score;
@@ -141,11 +184,157 @@ api_robot_get_score (void)
   return (scm_from_long (score));
 }
 
-void
-api_init (void)
+static SCM
+api_robot_is_alive (void)
+{
+  return SCM_BOOL (g_robot_is_alive (robot));
+}
+
+static SCM
+api_robot_get_move_energy_cost(void)
+{
+  return scm_from_long (g_robot_get_move_energy_cost());
+}
+static SCM
+api_robot_get_turn_energy_cost(void)
+{
+  return scm_from_long (g_robot_get_turn_energy_cost());
+}
+static SCM
+api_robot_get_feel_energy_cost(void)
+{
+  return scm_from_long (g_robot_get_feel_energy_cost());
+}
+static SCM
+api_robot_get_smell_energy_cost(void)
+{
+  return scm_from_long (g_robot_get_smell_energy_cost());
+}
+static SCM
+api_robot_get_look_energy_cost(void)
+{
+  return scm_from_long (g_robot_get_look_energy_cost());
+}
+static SCM
+api_robot_get_grab_energy_cost(void)
+{
+  return scm_from_long (g_robot_get_grab_energy_cost());
+}
+static SCM
+api_robot_get_zap_energy_cost(void)
+{
+  return scm_from_long (g_robot_get_zap_energy_cost());
+}
+
+/** Responsible for handling errors.
+ *
+ * \param[in] data
+ * \param[in] tag
+ * \param[in] throw_args
+ *
+ * \returns SCM_BOOL_F
+ */
+static SCM
+catch_handler(void *data, SCM tag, SCM throw_args)
+{
+  gchar *message = NULL;
+
+  if (scm_ilength (throw_args) > 1
+      && SCM_NFALSEP (scm_string_p (SCM_CADR (throw_args))))
+    {
+      message = scm_to_locale_string
+	(scm_simple_format (SCM_BOOL_F,
+			    SCM_CADR (throw_args),
+			    SCM_CADDR (throw_args)));
+    }
+
+  else if (SCM_NFALSEP (scm_symbol_p (tag)))
+    {
+      message = scm_to_locale_string (scm_symbol_to_string (tag));
+    }
+
+/*
+  user_interface_update_status (ui, message, -1, -1, -1);
+*/
+  if (message) {
+    g_print("Invalid Instruction: %s\n", message);
+    free (message);
+  } else {
+    g_print("Couldn't get error message\n");
+  }
+
+  return SCM_BOOL_F;
+}
+
+/** Helper function to load a file (robot_program) into Guile.
+ * 
+ * \param[in] robot_program a file name to load into Guile.
+ */
+static void
+api_load_robot_program(const gchar *robot_program)
+{
+  g_return_if_fail(robot_program != NULL);
+
+  if (strlen(robot_program) != 0)
+    {
+      /* execute a Scheme file */
+      g_print("Robot program: %s\n", robot_program);
+      scm_internal_catch(SCM_BOOL_T,
+			 (scm_t_catch_body) scm_c_primitive_load,
+			 (gpointer) robot_program,
+			 catch_handler, NULL);
+    }
+}
+
+/** Run Guile startup processes and imports.
+ * 
+ * When this function exits, the thread will call exit() for the
+ * program (terminating it).
+ *
+ * \param[in] robot_program a file name to load into Guile.
+ */
+static void
+api_repl_init(const gchar *robot_program)
+{
+  scm_internal_catch(SCM_BOOL_T,
+		     (scm_t_catch_body) scm_c_eval_string,
+		     "(sigaction SIGUSR1 (lambda (flags) (error \"User Interrupt\")))",
+		     catch_handler, NULL);
+  scm_internal_catch(SCM_BOOL_T,
+		     (scm_t_catch_body) scm_c_use_module,
+		     "ice-9 readline",
+		     catch_handler, NULL);
+  scm_internal_catch(SCM_BOOL_T,
+		     (scm_t_catch_body) scm_c_use_module,
+		     "gnurobots robot",
+		     catch_handler, NULL);
+  scm_internal_catch(SCM_BOOL_T,
+		     (scm_t_catch_body) scm_c_eval_string,
+		     "(activate-readline)",
+		     catch_handler, NULL);
+  scm_internal_catch(SCM_BOOL_T,
+		     (scm_t_catch_body) scm_c_use_module,
+		     "system repl repl",
+		     catch_handler, NULL);
+
+  if (NULL != robot_program)
+    api_load_robot_program(robot_program);
+
+  g_print("Entering interactive mode (REPL)...\n");
+  scm_internal_catch(SCM_BOOL_T,
+		     (scm_t_catch_body) scm_c_eval_string,
+		     "(start-repl)",
+		     catch_handler, NULL);
+}
+
+/** Define some new builtins (hooks) so that they are available in
+ * Scheme.
+ *
+ * \param[in] data Not used.
+ */
+static void
+api_define_procedures (gpointer data)
 {
-  /* define some new builtins (hooks) so that they are available in
-     Scheme. */
 
   /* Guile has this function set to expect that function-pointers are
      passed as (void *), which generates warnings because it's actually
@@ -156,17 +345,128 @@ api_init (void)
   typedef SCM (*c99_fakeout_guile)(const char *, int, int, int, SCM(*)());
   c99_fakeout_guile define_gsubr = (c99_fakeout_guile) scm_c_define_gsubr;
   define_gsubr ("robot-turn", 1, 0, 0, api_robot_turn);
+  scm_c_export("robot-turn");
   define_gsubr ("robot-move", 1, 0, 0, api_robot_move);
+  scm_c_export("robot-move");
   define_gsubr ("robot-smell", 1, 0, 0, api_robot_smell);
+  scm_c_export("robot-smell");
   define_gsubr ("robot-feel", 1, 0, 0, api_robot_feel);
+  scm_c_export("robot-feel");
   define_gsubr ("robot-look", 1, 0, 0, api_robot_look);
+  scm_c_export("robot-look");
   define_gsubr ("robot-grab", 0, 0, 0, api_robot_grab);
+  scm_c_export("robot-grab");
   define_gsubr ("robot-zap", 0, 0, 0, api_robot_zap);
+  scm_c_export("robot-zap");
 
   define_gsubr ("robot-get-shields", 0, 0, 0, api_robot_get_shields);
+  scm_c_export("robot-get-shields");
   define_gsubr ("robot-get-energy", 0, 0, 0, api_robot_get_energy);
+  scm_c_export("robot-get-energy");
   define_gsubr ("robot-get-score", 0, 0, 0, api_robot_get_score);
+  scm_c_export("robot-get-score");
+  define_gsubr ("robot-is-alive?", 0, 0, 0, api_robot_is_alive);
+  scm_c_export("robot-is-alive?");
+  define_gsubr ("robot-set-move-delay!", 1, 0, 0, api_set_move_delay_x);
+  scm_c_export("robot-set-move-delay!");
+
+  define_gsubr ("robot-get-move-energy-cost", 0, 0, 0,
+		api_robot_get_move_energy_cost);
+  scm_c_export("robot-get-move-energy-cost");
+  define_gsubr ("robot-get-turn-energy-cost", 0, 0, 0,
+		api_robot_get_turn_energy_cost);
+  scm_c_export("robot-get-turn-energy-cost");
+  define_gsubr ("robot-get-feel-energy-cost", 0, 0, 0,
+		api_robot_get_feel_energy_cost);
+  scm_c_export("robot-get-feel-energy-cost");
+  define_gsubr ("robot-get-smell-energy-cost", 0, 0, 0,
+		api_robot_get_smell_energy_cost);
+  scm_c_export("robot-get-smell-energy-cost");
+  define_gsubr ("robot-get-look-energy-cost", 0, 0, 0,
+		api_robot_get_look_energy_cost);
+  scm_c_export("robot-get-look-energy-cost");
+  define_gsubr ("robot-get-grab-energy-cost", 0, 0, 0,
+		api_robot_get_grab_energy_cost);
+  scm_c_export("robot-get-grab-energy-cost");
+  define_gsubr ("robot-get-zap-energy-cost", 0, 0, 0,
+		api_robot_get_zap_energy_cost);
+  scm_c_export("robot-get-zap-energy-cost");
 
   define_gsubr ("stop", 0, 0, 0, api_robot_stop);
+  scm_c_export("stop");
   define_gsubr ("quit", 0, 0, 0, api_robot_stop);
+  scm_c_export("quit");
+}
+
+/** The main program code that is executed after Guile starts up. 
+ *
+ * Pass the Scheme program as argv[1]. The program name is still
+ * argv[0].
+ *
+ * Attempts to load the scheme file if argc > 1 (using argv[1]).
+ *
+ * \param[in] closure not normally set (acceptable to pass NULL).
+ * \param[in] argc The number of arguments Guile can processin in argv.
+ * \param[in] argv The commandline arguments as strings.
+ */
+static void
+api_main_prog(void *closure, gint argc, gchar *argv[])
+{
+  scm_c_define_module("gnurobots robot", api_define_procedures, NULL);
+
+  gchar *robot_program = NULL;
+  if(argc > 1)
+    robot_program = argv[1];
+
+  api_repl_init(robot_program);
+}
+
+/** Structure to hold argc and argv to be passed to api_callback_scm.
+ */
+struct _ProgramArguments
+{
+  gint    argc; /*!< Number of arguments being passed in argv. */
+  gchar **argv; /*!< Arguments being passed as strings. */
+};
+
+/** Typedef to hold argc and argv to be passed to api_callback_scm.
+ */
+typedef struct _ProgramArguments ProgramArguments;
+
+/** Function to serve as the mainline in the Guile thread.
+ *
+ * \param[in] ProgramArguments struct to hold the values argc and argv
+ *            for processing.
+ *
+ * \returns NULL.  Note: does not normally return at all as the end of
+ *                 the Guile thread calls exit on the process.
+ */
+static gpointer
+api_callback_scm(ProgramArguments *args)
+{
+  scm_boot_guile(args->argc, args->argv, api_main_prog, NULL);
+
+  return NULL; /* never gets here, but keeps compiler happy */
+}
+
+void
+api_interrupt(void)
+{
+  raise(SIGUSR1);
+}
+
+GThread*
+api_init(gint argc, gchar **argv, gpointer in_robot)
+{
+  g_return_val_if_fail(G_IS_ROBOT(in_robot), NULL);
+
+  robot = g_object_ref(G_ROBOT(in_robot));
+
+  ProgramArguments *args = g_malloc(sizeof(ProgramArguments));
+  args->argc = argc;
+  args->argv = argv;
+
+  GThread *guile_thread = g_thread_new("Guile Thread", (GThreadFunc) api_callback_scm, args);
+
+  return guile_thread;
 }
diff --git a/src/grobot.c b/src/grobot.c
index 73e12a0..489e2f6 100644
--- a/src/grobot.c
+++ b/src/grobot.c
@@ -19,34 +19,49 @@
 
 #include "grobot.h"
 #include "configs.h"
-#include <stdio.h>
 #include <glib.h>
-#include <string.h>
-#include <stdlib.h>
+#include <stdarg.h>
 
-G_DEFINE_TYPE(GRobot, g_robot, G_TYPE_OBJECT)
+enum robot_signals
+{
+ DEATH,
+ STATS_UPDATE,
+ LAST_SIGNAL
+};
 
-enum
+enum robot_stats
 {
-	DEATH,
-	LAST_SIGNAL
+ ARG_0,
+ ARG_SCORE,
+ ARG_ENERGY,
+ ARG_SHIELDS,
+ ARG_UNITS,
+ ARG_SHOTS,
+ ARG_MAP
 };
 
-enum
-{
-	ARG_0,
-	ARG_POS_X,
-	ARG_POS_Y,
-	ARG_DIRECTION,
-	ARG_SCORE,
-	ARG_ENERGY,
-	ARG_SHIELDS,
-	ARG_UNITS,
-	ARG_SHOTS,
-	ARG_USER_INTERFACE,
-	ARG_MAP
+enum robot_actions
+{
+ ACTION_MOVE,
+ ACTION_TURN,
+ ACTION_FEEL,
+ ACTION_SMELL,
+ ACTION_LOOK,
+ ACTION_GRAB,
+ ACTION_ZAP,
+ ACTION_LAST_ACTION
 };
 
+static const glong action_energy_cost[ACTION_LAST_ACTION] =
+  {2, /* ACTION_MOVE */
+   2, /* ACTION_TURN */
+   1, /* ACTION_FEEL */
+   1, /* ACTION_SMELL */
+   1, /* ACTION_LOOK */
+   5, /* ACTION_GRAB */
+   10 /* ACTION_ZAP */
+  };
+
 static gchar *things[] = { "space", "food", "prize", "wall", "baddie",
 	"robot"
 };
